
format binary as "" ;"kex"
use32
org 0x0    ;    ,  0x0

UNLOCKd = 0
LOCKd = 1

; 
db 'MENUET01'     ; 
dd 0x01           ;
dd START_DEBUG          ;   
dd I_END          ; ,     
dd 0x100000       ; -    
dd 0x7fff0        ;   esp -             
dd 0, 0           ;        


include './BSI/macros.inc'

START_DEBUG:
   mcall  68, 11         ; 
   call loadConfig ;  
   mov ebx, 00000100000000000000000000100000b ;    
   mcall 40

;  mov  eax, -1      ;  -1 :   
 ; mcall

START:
  mov     eax, 10                 ; function 10 : wait until event
  mcall                           ; event type is returned in eax

  cmp   eax, 6            ;    
  je    mouse

  jmp START

mouse:
  ;  
  call get_mouse_pos ;   

  cmp eax, 0 ;  
  jne @f
  ; --   .       (X=0, Y=0)
  push ecx
  mov ecx, 0
  call run_command
  pop ecx

  jmp START ;finish
@@:
  call get_screen_size ;   

  cmp ax, word[screen.height]    ;Ymouse = Yscreen ?
  je Ytrue
  ; Y  ,    Y=0  X=ScreenWidth (  )

  cmp ax, 0
  jne unlockend
  shr eax, 16
  cmp ax, word[screen.width]
  jne unlockend
  ; --      
  push ecx
  mov ecx, 2
  call run_command
  pop ecx

  jmp START
Ytrue:
  ; Y ,    X=0 (  )  X=ScreenWidth ( )
  shr eax, 16
  cmp ax, 0
  jne @f
  ; -- X=0, Y = Height  (  )
  push ecx
  mov ecx, 1
  call run_command
  pop ecx
  jmp START
@@:
  cmp ax, word[screen.width]
  jne unlockend
  ; -- (  )
  push ecx
  mov ecx, 3
  call run_command
  pop ecx

  jmp START

unlockend:
  mov byte[state], UNLOCKd
  jmp START


;     
screen:
   .width  dw 0
   .height dw 0
;  
get_screen_size:
   push eax
   mcall 14
   ;  eax = [xsize]*65536 + [ysize]
   ;mov dword[screen], eax
   mov word[screen.height], ax
   shr eax, 16
   mov word[screen.width], ax
   pop eax
   ret


;  
get_mouse_pos:
   ;push eax
   push ebx
   mcall 37, 0
   pop ebx
   ;pop eax
   ret


; : ecx -  : lu=0, ld=1, ru=2, rd=3
run_command:
   cmp byte[state], UNLOCKd
   jne run_command.end

   push eax
   push ebx
   push ecx


   cmp ecx, 0
   jne @f
   mov eax, dword[newData.lu] ;testData.lu
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 1
   jne @f
   mov eax, dword[newData.ld]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 2
   jne @f
   mov eax, dword[newData.ru]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 3
   jne .end_set_path
   mov eax, dword[newData.rd]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
.end_set_path:

   ;
   ;mov dword[struct.adr],

;   -   0,    
   cmp dword[struct70.path_adr], 0
   jne .next
   mov eax, testData.ld    ;
   mov dword[struct70.path_adr], eax
.next:
;   

   mcall 70, struct70
   mov byte[state], LOCKd

   pop ecx
   pop ebx
   pop eax
.end:
   ret

struct70: ;  
  .func       dd 7 ;  
  .mask       dd 0
  .param_adr  dd 0 ;   ASCIIZ-  
  .other      dd 0, 0
  .path       db 0 ; "/rd/1/TINYPAD",0 ; 
  .path_adr   dd 0 ;testData.lu ;0


state: db 0 ; 0=unlock, 1=lock

testData:
  .lu db '/rd/1/SHELL', 0
  .ld db '/rd/1/RUN', 0
  .ru db "/rd/1/TINYPAD", 0
  .rd db '/rd/1/File Managers/EOLITE', 0

newData:  ;   
  .lu dd 0
  .ld dd 0
  .ru dd 0
  .rd dd 0
newDataEnd:

;  
fileName: db 'aa.cfg', 0

loadConfig:
   push eax
   push ebx
   push ecx
   push edx
   mcall 68, 27, fileName   ;    
   cmp eax, 0
   je loadConfig.exit       ;   ,    
   ;    ,   edx
   cmp edx, 0               ;  ,    ,   
   je loadConfig.exit

   add edx, eax             ;   edx -   

   cmp byte[eax], 121 ;'y'  ;     :  
   jne loadConfig.exit      ;   

   push edi
   push esi
   ;   edi       
   mov edi, newData
   ;      0  
   mov esi, eax
.block:
   inc esi
   cmp byte[esi], 10         ;    10  13,   
   je loadConfig.propusk     ;    
   cmp byte[esi], 13
   je loadConfig.propusk

   ;         -  
   mov dword[edi], esi
   add edi, 4

   ;    :     10, 13, 0  file end
.while:
   inc esi
   cmp esi, edx           ;   -   ,     !!! 
   jae loadConfig.fileend
   cmp byte[esi], 10
   je loadConfig.ura
   cmp byte[esi], 0
   je loadConfig.ura
   cmp byte[esi], 13
   jne loadConfig.while
.ura:
   mov byte[esi], 0

   cmp edi, newDataEnd ;newData.end      ;    ,    
   jb loadConfig.block
.fileend:

   pop esi
   pop edi

   jmp loadConfig.end

.propusk:
   mov byte[esi], 0
   jmp loadConfig.block
.exit:
   pop edx
   pop ecx
   pop ebx
   pop eax
   mcall -1 ;  
.end:
   pop edx
   pop ecx
   pop ebx
   pop eax
   ret


I_END:
